Page MenuHomePhabricator

Wikimedia Technical Conference 2018 Session - Mapping our data and content pipeline
Closed, ResolvedPublic

Description

Session Themes and Topics

  • Theme: Architecting our code for change and sustainability
  • Topic: Turning data into HTML (beyond the parser)

Session Leader

  • Raz

Facilitator

  • John Bennett

Description

As MediaWiki moves towards an API-first architecture, we need to maintain compatibility for legacy clients as well as extensions that still produce HTML directly. In this session, we’ll discuss when, where and how data gets turned into HTML, and what compatibility layers are needed for this.

Questions to answer during this session

QuestionSignificance: Why is this question important? What is blocked by it remaining unanswered?
When, where, and how is data turned in to HTML in MediaWiki (other than in the parser itself)?Obviously, the wikitext parser is the primary way that data gets turned in to HTML within the context of MediaWiki. SpecialPages and Action handlers are other ways. Enumerating the paths that result in rendered content is a necessary step towards an API-first world.
While we move towards an API-first architecture, how do we serve consumers that do not support client side rendering?For the foreseeable future, we will need to support clients that do not support client side rendering. To do so, we need to decide where the rendering can happen for such clients, whether it can use the same code/templates as the client side rendering, how it is cached, etc.
While we move towards an API-first architecture, how do we handle extensions (and core code) that cannot be quickly ported to serve JSON instead of rendered HTML?Changing application logic from emitting HTML to emitting data structures is a gradual process. Client side rendering mechanisms will need a mechanism to integrate HTML generated by legacy code.
When implementing client-side rendering, how do we minimize callbacks to the server side API for miscellaneous tasks like rendering localization messages?One major roadblock for client side logic has been the fact that MediaWiki’s localization mechanism is based on WikiText, and needs a WikiText parser to function. Listing alternative and options for this issue is essential to planning the migration to an API-first architecture.

Facilitator and Scribe notes

Facilitator reminders

Session Structure

  • Define session scope, clarify desired outcomes, present agenda
  • Discuss Focus Areas
    • Discuss and Adjust. ''Note that we are not trying to come to a final agreement, we are just prioritizing and assigning responsibilities!''
    • For each proposition [add etherpad link here]
      • Decides whether there is (mostly) agreement or disagreement and the proposition(s).
      • Decide whether there is more need for discussion on the topic, and how urgent or important that is.
      • Identify any open questions that need answering from others, and from who (product, ops, etc)
      • Decides who will drive the further discussion/decision process (ie: a four month deadline)
  • Discuss additional strategy questions [add etherpad link here]. For each question:
    • Decide whether it is considered important.
    • Discuss who should answer it.
    • Decide who will follow up on it.
  • Wrap up

Session Leaders please:

  • Add more details to this task description.
  • Coordinate any pre-event discussions (here on Phab, IRC, email, hangout, etc).
  • Outline the plan for discussing this topic at the event.
  • Optionally, include what it will not try to solve.
  • Update this task with summaries of any pre-event discussions.
  • Include ways for people not attending to be involved in discussions before the event and afterwards.

Post-event Summary:

  • ...

Action items:

  • ...

Event Timeline

debt created this task.Oct 2 2018, 10:55 PM
Restricted Application added a subscriber: Aklapper. · View Herald TranscriptOct 2 2018, 10:55 PM
kchapman renamed this task from Wikimedia Technical Conference 2018 Session - Turning data into HTML (beyond the parser) to Wikimedia Technical Conference 2018 Session - Mapping our data and content pipeline.Oct 3 2018, 2:44 AM
debt updated the task description. (Show Details)Oct 4 2018, 11:55 PM
debt updated the task description. (Show Details)Oct 10 2018, 1:54 PM
debt added a subscriber: tstarling.
Quiddity updated the task description. (Show Details)Oct 20 2018, 1:28 AM
debt updated the task description. (Show Details)Oct 21 2018, 7:42 PM
tstarling updated the task description. (Show Details)Oct 24 2018, 5:02 PM
daniel updated the task description. (Show Details)Nov 23 2018, 2:50 PM

Hello! We are starting to ramp up on session creation for the 2019 Wikimedia Technical Conference. If there is no longer anything remaining to do here please close this task to avoid confusion.

daniel closed this task as Resolved.Thu, Sep 12, 10:28 AM
daniel claimed this task.